WITH   Ada.Unchecked_Conversion ;
WITH   Interfaces.C ;
WITH   System ;
WITH   Win32 ;
WITH   Win32.Crt.Strings ;
WITH   Win32.Windef ;
WITH   Win32.Wingdi ;
WITH   Win32.Winuser ;

PACKAGE BODY   HelloWo5_Pkg  IS

   FUNCTION   CP   ( I_Str : Win32.CHAR_Array )  RETURN  Win32.LPCSTR  IS
      FUNCTION   UC  IS
         new Ada.Unchecked_Conversion ( System.Address , Win32.LPCSTR );
   BEGIN
      RETURN  UC ( I_Str(I_Str'First)'Address );
   END CP;

   FUNCTION   CPS   ( I_Str : Win32.CHAR_Array )  RETURN  Win32.LPSTR  IS
      FUNCTION   UC  IS
         new Ada.Unchecked_Conversion ( System.Address , Win32.LPSTR );
   BEGIN
      RETURN  UC ( I_Str(I_Str'First)'Address );
   END CPS;

   FUNCTION   To_IntW  IS  new Ada.Unchecked_Conversion(Win32.PCHAR, Integer);
   FUNCTION   To_PCHAR  IS  new Ada.Unchecked_Conversion(Integer, Win32.PCHAR);

   USE TYPE   Win32.CHAR_Array ;      --- To get "&"

   Nul : Win32.Char RENAMES Win32.Nul ;

   IgnoredP : Win32.PSTR ;

   C_HelloMsg : CONSTANT Win32.CHAR_Array := "Hello World....."  &  Nul ;
   CRLFz : CONSTANT Win32.CHAR_Array := Win32.Char(Character'Val(13))  &  Win32.Char(Character'Val(10))  &  Nul ;

   L_PaintStruct : ALIASED Win32.Winuser.PAINTSTRUCT ;
   L_Rect        : ALIASED Win32.Windef.RECT := (0,0,0,0);

   L_Buffer : ALIASED Win32.CHAR_Array(0..255);

   FUNCTION   MainWindow_Proc   ( I_HWnd    : Win32.Windef.HWND
                                ; I_Message : Win32.UINT
                                ; I_WParam  : Win32.WPARAM
                                ; I_LParam  : Win32.LPARAM )  RETURN  Win32.LRESULT  IS
      L_HDC : Win32.Windef.HDC ;

      L_P : Win32.LPSTR ;
      L_TmpLen : Standard.INTEGER ;
   BEGIN
      CASE I_Message IS
         WHEN Win32.Winuser.WM_PAINT =>
            L_HDC := Win32.Winuser.BeginPaint ( I_HWnd , L_PaintStruct'Access );
            IgnoredB := Win32.Winuser.GetClientRect ( I_HWnd , L_Rect'Access );

            L_P := CPS(L_Buffer);

            IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(C_HelloMsg) );
            IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(CRLFz) );
            L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
            L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);

            IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(C_HelloMsg) );
            IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(CRLFz) );
            L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
            L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);

            IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(C_HelloMsg) );
            IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(CRLFz) );
            L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
            L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);

            IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(C_HelloMsg) );
            IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(CRLFz) );
            L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
            L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);

            IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(C_HelloMsg) );
            IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(CRLFz) );
            L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
            L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);

            IgnoredI := Win32.Winuser.DrawText ( L_HDC
                                               , CP(L_Buffer)
                                               , Interfaces.C.Int( Win32.Crt.Strings.StrLen(CP(L_Buffer)) )
                                               , L_Rect'Access
                                               , Win32.Winuser.DT_WORDBREAK );

            IgnoredB := Win32.Winuser.EndPaint ( L_HDC , L_PaintStruct'Access );

         WHEN Win32.Winuser.WM_SIZE =>      --- When window is resized,...
            ----- Force paint again
            IgnoredB := Win32.Winuser.GetClientRect ( I_HWnd , L_Rect'Access );
            IgnoredB := Win32.Winuser.InvalidateRect ( I_HWnd , L_Rect'Access , Win32.FALSE );

         WHEN Win32.Winuser.WM_DESTROY =>
            Win32.Winuser.PostQuitMessage(0);

         WHEN OTHERS =>
            RETURN  Win32.Winuser.DefWIndowProc ( I_HWnd , I_Message , I_WParam , I_LParam );
      END CASE;

      ----- Default result : Msg processed!!!
      RETURN  0 ;
   END MainWindow_Proc;
END HelloWo5_Pkg;
